-- author: Procobator
-- date: 03.16.20
-- Code is free to use for non-commercial purposes
-- version: farming simulator 19

MarkerExtension = {} 

function MarkerExtension.prerequisitesPresent(specializations) return 
	SpecializationUtil.hasSpecialization(RidgeMarker, specializations) 
end; 
	
function MarkerExtension.registerEventListeners(vehicleType) 
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", MarkerExtension);
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", MarkerExtension);
end; 

function MarkerExtension:onLoad(savegame)
	self.MarkerExtension = {};
	self.MarkerExtension.actionEvents = {};	
end;
	
function MarkerExtension:onRegisterActionEvents(isActiveForInput)

    if self.isClient then
			local spec = self.MarkerExtension;
			self:clearActionEventsTable(spec.actionEvents);
			spec.actionEventIds = {};			
		if self:getIsActiveForInput(true, true) then
            local _, actionEventId = self:addActionEvent(spec.actionEvents, "leftRidgeMarker", self, MarkerExtension.onInputAction, false, true, false, true, nil);
            g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL);
            g_inputBinding:setActionEventTextVisibility(actionEventId, true);
			table.insert(spec.actionEventIds, actionEventId);	
			local _, actionEventId = self:addActionEvent(spec.actionEvents, "rightRidgeMarker", self, MarkerExtension.onInputAction, false, true, false, true, nil);
            g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL);
            g_inputBinding:setActionEventTextVisibility(actionEventId, true);
			table.insert(spec.actionEventIds, actionEventId);			
			if actionEventId == "" then
				local _, actionEventId = self:addActionEvent(spec.actionEvents, "leftRidgeMarker", self, MarkerExtension.onInputAction, false, true, false, true, nil);
				g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL);
				g_inputBinding:setActionEventTextVisibility(actionEventId, true);
				table.insert(spec.actionEventIds, actionEventId);
				local _, actionEventId = self:addActionEvent(spec.actionEvents, "rightRidgeMarker", self, MarkerExtension.onInputAction, false, true, false, true, nil);
				g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL);
				g_inputBinding:setActionEventTextVisibility(actionEventId, true);
				table.insert(spec.actionEventIds, actionEventId);
			end;
        end;
    end;

end;


function MarkerExtension.onInputAction(self, actionName, inputValue, callbackState, isAnalog)
	

	if actionName == "leftRidgeMarker" then
		local spec = self.spec_ridgeMarker
			if spec.ridgeMarkerState == 0 and self:getIsTurnedOn() then
				self:setRidgeMarkerState(1)
			elseif spec.ridgeMarkerState == 1 then
				self:setRidgeMarkerState(0)
			end;
				print(state)
	end;
	
	if actionName == "rightRidgeMarker" then
		local spec = self.spec_ridgeMarker
			if spec.ridgeMarkerState == 0 and self:getIsTurnedOn() then
				self:setRidgeMarkerState(2)
			elseif spec.ridgeMarkerState == 2 then
				self:setRidgeMarkerState(0)
			end;
	end;
		
end;
	
